'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Tracker = function () {
  (0, _createClass3.default)(Tracker, null, [{
    key: 'ACTION_HIT',
    get: function get() {
      return 'hits';
    }
  }, {
    key: 'ACTION_MISSING',
    get: function get() {
      return 'misses';
    }
  }, {
    key: 'ENV_SERVER',
    get: function get() {
      return 'server';
    }
  }, {
    key: 'ENV_BROWSER',
    get: function get() {
      return 'browser';
    }
  }]);

  function Tracker() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        algorithm = _ref.algorithm,
        fnName = _ref.fnName,
        host = _ref.host,
        _ref$port = _ref.port,
        port = _ref$port === undefined ? 80 : _ref$port,
        _ref$protocol = _ref.protocol,
        protocol = _ref$protocol === undefined ? 'http' : _ref$protocol,
        segmentation = _ref.segmentation,
        env = _ref.env;

    (0, _classCallCheck3.default)(this, Tracker);

    this._algorithm = algorithm;
    this._env = env;
    this._fnName = fnName;
    this._host = host;
    this._port = port;
    this._protocol = protocol;
    this._segmentation = segmentation;

    this._resetStats();
  }

  (0, _createClass3.default)(Tracker, [{
    key: 'track',
    value: function track() {
      var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          action = _ref2.action;

      if (!this._host || !this._segmentation) {
        return;
      }

      if (this._shouldSend()) {
        this._send({
          headers: { 'x-payload': (0, _stringify2.default)((0, _extends4.default)({
              algorithm: this._algorithm,
              env: this._env,
              fnName: this._fnName
            }, this._stats)) },
          hostname: this._host.replace(/(https?)?:?\/\//g, ''),
          path: '/__tracking/cache/event/stats',
          port: this._port
        });
        this._resetStats();
      }
    }
  }, {
    key: '_updateStats',
    value: function _updateStats() {
      var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          action = _ref3.action;

      this._stats = (0, _extends4.default)({}, this._stats, (0, _defineProperty3.default)({}, action, ++this._stats[action]));
    }
  }, {
    key: '_resetStats',
    value: function _resetStats() {
      var _stats;

      this._stats = (_stats = {}, (0, _defineProperty3.default)(_stats, Tracker.ACTION_HIT, 0), (0, _defineProperty3.default)(_stats, Tracker.ACTION_MISSING, 0), _stats);
    }
  }, {
    key: '_send',
    value: function _send() {
      var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          path = _ref4.path,
          headers = _ref4.headers,
          hostname = _ref4.hostname;

      throw new Error('[Tracker#_send] must be implemented');
    }
  }, {
    key: '_shouldSend',
    value: function _shouldSend() {
      return Math.floor(Math.random() * 100) + 1 <= this._segmentation;
    }
  }]);
  return Tracker;
}();

exports.default = Tracker;