'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var stringOrIntToMs = function stringOrIntToMs(_ref) {
  var ttl = _ref.ttl;

  var RADIX = 10;

  if (typeof ttl === 'number') {
    return ttl;
  }

  var _ttl$split = ttl.split(' '),
      _ttl$split2 = (0, _slicedToArray3.default)(_ttl$split, 2),
      unit = _ttl$split2[0],
      amount = _ttl$split2[1];

  try {
    unit = parseInt(unit, RADIX);
  } catch (e) {
    return false;
  }

  switch (amount) {
    case 'second':
    case 'seconds':
      return unit * 1000;

    case 'minute':
    case 'minutes':
      return unit * 1000 * 60;

    case 'hour':
    case 'hours':
      return unit * 1000 * 60 * 60;

    default:
      return false;
  }
};

exports.default = stringOrIntToMs;